Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/CQLQuery.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/CQLQuery.java	(revision 0)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/CQLQuery.java	(revision 1061)
@@ -0,0 +1,386 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate: 2015-05-13 09:46:56 +0200 (Wed, 13 May 2015) $
+// $LastChangedRevision: 2967 $
+// $LastChangedBy: mdecorde $ 
+//
+package org.txm.searchengine.cqp.corpus.query;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
+
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.searchengine.core.Query;
+
+/**
+ * Implements a CQL query. Use fixQuery to use query sugar.
+ * 
+ * @author sloiseau
+ * @author jpmague
+ * @author sheiden
+ * @author sjacquot
+ */
+
+public class CQLQuery implements Query {
+
+	/** The Constant NoStrategy. */
+	private static final Integer NoStrategy = 0;
+	
+	/** The Constant JPMStrategy. */
+	private static final Integer JPMStrategy = 1;
+	
+	/** The Constant WLXStrategy. */
+	private static final Integer WLXStrategy = 2;
+	
+	/** The Constant ElectricStrategy. */
+	private static final Integer ElectricStrategy = 3;
+
+
+	/** espace char |"{()}+*. */
+	private static String chars = "^$<>|\\\"{([])}?+*."; //$NON-NLS-1$
+
+	
+	/**
+	 * The query string.
+	 */
+	protected String queryString;
+
+
+	
+	/**
+	 * Instantiates a new query.
+	 */
+	protected CQLQuery() {
+	}
+
+	/**
+	 * Instantiates a new query.
+	 * 
+	 * @param queryString
+	 *            the query string
+	 * 
+	 *            public Query(String queryString){
+	 *            this.queryString=queryString.trim(); }
+	 */
+	public CQLQuery(String queryString) {
+		if (queryString != null) {
+			this.queryString = queryString.trim();
+		}
+		else {
+			this.queryString = "";
+		}
+	}
+
+	/**
+	 * Converts the specified string to a list of Query.
+	 * Input string must contains queries separated by a tabulation.
+	 * @param str
+	 * @return
+	 */
+	public static List<CQLQuery> stringToQueries(String str) {
+		ArrayList<CQLQuery> queries = new ArrayList<CQLQuery>();
+		if (str == null || str.length() == 0) {
+			return queries;
+		}
+		String[] split = str.split(TXMPreferences.LIST_SEPARATOR);
+		for (String s : split) {
+			queries.add(new CQLQuery(s));
+		}
+		return queries;
+	}
+
+	
+	/**
+	 * Converts the specified list of Query to a string.
+	 * Queries strings are separated by a tabulation.
+	 * @param queries
+	 * @return
+	 */
+	public static String queriesToString(List<CQLQuery> queries) {
+		String str = "";
+		for (int i = 0; i < queries.size(); i++) {
+			if(i > 0)	{
+				str += TXMPreferences.LIST_SEPARATOR;
+			}
+			str += queries.get(i).getQueryString();			
+		}
+		return str;
+	}
+
+	
+	/**
+	 * Gets the query string.
+	 * 
+	 * @return the query string
+	 */
+	public String getQueryString() {
+		return queryString;
+	}
+
+	/* (non-Javadoc)
+	 * @see java.lang.Object#toString()
+	 */
+	@Override
+	public String toString() {
+		return queryString;
+	}
+
+	/**
+	 * Normalize white chars.
+	 * 
+	 * SLH algorithm :
+		 * - first normalize white chars : We don't know from where the query
+		 * comes from and how it was produced (pasted from a text editor after
+		 * having been double-clicked and copied, typed in the query input
+		 * field, etc.) The CQP syntax analyzer is sensible to white chars, so
+		 * we have to normalize what the user may have leaved inadvertently
+		 * because she may not see well the true query string (white chars are
+		 * invisible), and it is dif ficult to accept and manage a syntax error
+		 * when you can't "see" the source of the problem. That strategy decides
+		 * to interpret every white chars contiguous sequence as one space
+		 * character.
+		 * 
+		 * Please note that this may be compatible (or not) with other Search
+		 * Engines query scanners.
+		 * 
+		 * Please note also that this may be compatible (or not) with the
+		 * tokenization policy of a given corpus dealing with compound words.
+		 * That strategy is compatible with a policy which separates words in
+		 * compound words by one space character.
+		 * 
+		 * - then remove outer white chars : What is not seen should not be
+		 * there if no explicit expression deals with it from the user's point
+		 * of view. So white chars at the beginning or at the end of the query
+		 * are removed. Those characters often come from rapid copy/paste or
+		 * double-click/copy/paste (in a word processing software, the
+		 * double-click strategy can for example select the white chars on the
+		 * right of the selected strings to help the user move words around with
+		 * their delimiters).
+		 * 
+		 * That strategy may seem aggressive, but experience shows that this
+		 * little service helps silently users a lot and is rarely
+		 * inappropriate.
+		 * 
+		 * In case of doubt, the user should be able to switch to another
+		 * strategy.
+	 *
+	 * @param str the str
+	 * @return the string with white chars normalized
+	 */
+	public static String normalizeWhiteChars(String str) {
+
+		// normalize everything white to space
+		String str1 = str.replaceAll("\\s+", " "); //$NON-NLS-1$ //$NON-NLS-2$
+		// remove border whites
+		str1 = str1.replaceFirst("^ ", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		str1 = str1.replaceFirst(" $", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		return str1;
+	}
+
+	/**
+	 * Transforms a simplified query string into a proper CQP query string
+	 * 
+	 * Follows several different strategies to do that :
+	 * 
+	 * JPM Strategy : if the input query matches \w quote are added if the input
+	 * query matches \w*="\w*", square brackets are added if the input query
+	 * matches .\w=.\w (i.e. without quotes), quotes and square brackets are
+	 * added (i.e. -> [$1="$2"]) otherwise, the query is left as if 
+	 * 
+	 * Weblex Strategy : normalize white chars add double quotes if no double
+	 * quotes and no brackets
+	 * 
+	 * Electric Strategy : normalize white chars add double quote, equal,
+	 * brackets, etc. depending on the presence/absence of those chars in the
+	 * original query
+	 * 
+	 * No Strategy : do nothing
+	 * 
+	 * @param query
+	 *            The query string to fix
+	 * @return the fixed query string
+	 */
+	static public String fixQuery(String query) {
+
+		//if (query.startsWith("intersect ")) return query;
+
+		if ("\"".equals(query)) return "\"\\\"\""; //$NON-NLS-1$ //$NON-NLS-2$
+		
+		Integer QueryFixStrategy = WLXStrategy;
+
+		if (QueryFixStrategy == JPMStrategy) {
+
+			// query = abc -> put double quotes
+			Pattern simple = Pattern.compile("\\p{L}*"); //$NON-NLS-1$
+			if (simple.matcher(query).matches()) {
+				// System.out.println("match 1");
+				return '"' + query + '"'; //$NON-NLS-1$
+			}
+
+			// query = prop="abc" -> put square brackets
+			Pattern equalsWithQuotes = Pattern.compile("\\p{L}+=\"\\p{L}*\""); //$NON-NLS-1$
+			if (equalsWithQuotes.matcher(query).matches()) {
+				// System.out.println("match 2");
+				return '[' + query + ']';
+			}
+
+			// query = abc=def -> put brackets + equal sign + double quotes
+			Pattern equalsWithoutQuotes = Pattern
+					.compile("(\\p{L}*)=(\\p{L}*)"); //$NON-NLS-1$
+			Matcher matcher = equalsWithoutQuotes.matcher(query);
+			if (matcher.matches()) {
+				// System.out.println("match 2");
+				return '[' + matcher.group(1) + '=' + '"' + matcher.group(2)
+						+ '"' + ']';
+			}
+
+			// query doesn't start with ", ' and [ -> put double quotes
+			if (!query.startsWith("\"") && !query.startsWith("\'") && !query.startsWith("[")) //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+			{
+				return '"' + query + '"'; //$NON-NLS-1$
+			}
+
+			// do nothing
+			return query;
+
+		} else if (QueryFixStrategy == WLXStrategy) {
+
+			query = normalizeWhiteChars(query);
+
+			// empty query
+			if(query.isEmpty())	{
+				return query;
+			}
+			// query contains double quotes
+			else if (query.contains("\"")) { //$NON-NLS-1$
+				return query;
+			}
+			// query contains brackets
+			else if (query.contains("[") && query.contains("]")) { //$NON-NLS-1$ //$NON-NLS-2$
+				return query; // probably [] or [...]
+			}
+			else {
+				return '"' + query + '"'; //$NON-NLS-1$
+			}
+		} else if (QueryFixStrategy == ElectricStrategy) {
+
+			// DON'T USE THAT STRATEGY : CODE NEEDS TO BE FIXED
+			query = normalizeWhiteChars(query);
+
+			if (query.contains("\"")) { //$NON-NLS-1$
+				if (query.contains("=")) { //$NON-NLS-1$
+					if (query.contains("[")) { //$NON-NLS-1$
+						return query;
+					} else {
+						return '[' + query + ']';
+					}
+				} else {
+					return query;
+				}
+			} else {
+				if (query.contains("=")) { //$NON-NLS-1$
+					return query.replaceAll("=([^= \"]+)", "=\"$1\""); //$NON-NLS-1$ //$NON-NLS-2$
+				} else {
+					return '"' + query + '"'; //$NON-NLS-1$
+				}
+			}
+		} else if (QueryFixStrategy == NoStrategy) {
+
+			// no strategy to apply : do nothing
+			return query;
+
+		} else {
+
+			// we shouldn't be there
+			// let silently return the query for the moment
+			return query;
+		}
+	}
+
+
+	
+	/**
+	 * Adds the back slash.
+	 *
+	 * @param squery the squery
+	 * @return the string
+	 */
+	public static String addBackSlash(String squery) {
+		if ("\"".equals(squery)) return "\"\\\"\""; //$NON-NLS-1$ //$NON-NLS-2$
+		StringBuffer buff = new StringBuffer();
+		//for(char c : chars.)
+		for(int i = 0 ; i < squery.length() ; i++) {
+			int j = chars.indexOf(squery.charAt(i));
+			//System.out.println(""+i+" : "+squery.charAt(i)+ " >> "+j);
+			
+			if ( j >= 0 ) {
+				buff.append("\\"+squery.charAt(i)); //$NON-NLS-1$
+			}
+			else {
+				buff.append(squery.charAt(i));
+			}
+		}
+		return buff.toString();
+	}
+
+
+	/**
+	 * Sets the string of the query. 
+	 * @param queryString
+	 */
+	public void setQueryString(String queryString) {
+		this.queryString = queryString;
+	}
+
+	/**
+	 * Checks whatever the query is empty (null, empty or contains only double quotes) or not.
+	 * @return true if empty otherwise false
+	 */
+	public boolean isEmpty() {
+		return queryString == null || queryString.length() == 0 || "\"\"".equals(queryString);
+	}
+
+	
+	@Override
+	public boolean equals(Object obj) {
+		if (!(obj instanceof CQLQuery)) {
+			return false;
+		}
+		return this.queryString.equals(((CQLQuery) obj).queryString);
+	}
+
+	
+	
+	/**
+	 * The main method.
+	 *
+	 * @param args the arguments
+	 */
+	public static void main(String[] args) {
+		String test = "^$sdf<>sdf|\\sdf\"{(sdf)}?+sdf*."; //$NON-NLS-1$
+		System.out.println(CQLQuery.addBackSlash(test));
+	}
+}

Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/QueryFocus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/QueryFocus.java	(revision 1060)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/QueryFocus.java	(revision 1061)
@@ -31,7 +31,7 @@
 /**
  * The Class QueryFocus.
  */
-public class QueryFocus extends Query {
+public class QueryFocus extends CQLQuery {
 
 	/** The focus. */
 	private final Focus focus;
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/QueryPart.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/QueryPart.java	(revision 1060)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/QueryPart.java	(revision 1061)
@@ -39,7 +39,7 @@
  * @author Jean Philippe Magué
  * @author sloiseau
  */
-public class QueryPart extends Query {
+public class QueryPart extends CQLQuery {
 
 	/** The structure. */
 	private StructuralUnit structure;
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Subcorpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Subcorpus.java	(revision 1060)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Subcorpus.java	(revision 1061)
@@ -43,7 +43,7 @@
 import org.txm.searchengine.cqp.clientExceptions.UnexpectedAnswerException;
 import org.txm.searchengine.cqp.core.functions.selection.SelectionResult;
 import org.txm.searchengine.cqp.corpus.query.Match;
-import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
 import org.txm.utils.logger.Log;
 import org.w3c.dom.Document;
@@ -64,7 +64,7 @@
 	protected Subcorpus motherSubcorpus;
 
 	/** The query. */
-	protected Query query;
+	protected CQLQuery query;
 
 	private SelectionResult selectionResult;
 	protected QueryResult qresult;
@@ -77,7 +77,7 @@
 	 * @param query
 	 * @throws InvalidCqpIdException
 	 */
-	protected Subcorpus(String cqpId, String name, Corpus parent, Query query) throws InvalidCqpIdException {
+	protected Subcorpus(String cqpId, String name, Corpus parent, CQLQuery query) throws InvalidCqpIdException {
 		this(cqpId, name, parent, query, true);
 	}
 	
@@ -91,9 +91,9 @@
 	 * @param parent the parent
 	 * @param query the query
 	 * @throws InvalidCqpIdException the invalid cqp id exception
-	 * {@link Corpus#createSubcorpus(Query, String)}
+	 * {@link Corpus#createSubcorpus(CQLQuery, String)}
 	 */
-	protected Subcorpus(String cqpId, String name, Corpus parent, Query query, boolean addToParent) throws InvalidCqpIdException {
+	protected Subcorpus(String cqpId, String name, Corpus parent, CQLQuery query, boolean addToParent) throws InvalidCqpIdException {
 		super(cqpId);
 		
 		// FIXME: to validate
@@ -274,7 +274,7 @@
 	@Override
 	protected boolean _load() {
 		if (getSelfElement() != null) {
-			this.query = new Query(getSelfElement().getAttribute("query")); //$NON-NLS-1$
+			this.query = new CQLQuery(getSelfElement().getAttribute("query")); //$NON-NLS-1$
 
 			NodeList subcorpusElems = getSelfElement().getElementsByTagName("subcorpus"); //$NON-NLS-1$
 			for (int i = 0 ; i < subcorpusElems.getLength() ; i++) {
@@ -338,7 +338,7 @@
 	 * @param subcorpusName the subcorpus name
 	 * @param query the query
 	 */
-	private void registerToParent(String subcorpusName, Query query) {
+	private void registerToParent(String subcorpusName, CQLQuery query) {
 		if (this.getSelfElement() == null && this.getParent() != null)
 			try {
 				Element parentElem = (Element) this.getParent().getSelfElement();
@@ -377,7 +377,7 @@
 	 *
 	 * @return the query
 	 */
-	public Query getQuery() {
+	public CQLQuery getQuery() {
 		return query;
 	}
 
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/QueryResult.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/QueryResult.java	(revision 1060)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/QueryResult.java	(revision 1061)
@@ -38,7 +38,7 @@
 import org.txm.searchengine.cqp.clientExceptions.InvalidCqpIdException;
 import org.txm.searchengine.cqp.clientExceptions.UnexpectedAnswerException;
 import org.txm.searchengine.cqp.corpus.query.Match;
-import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
 
 /**
@@ -64,7 +64,7 @@
 	protected Corpus queriedCorpus;
 
 	/** The query. */
-	protected Query query;
+	protected CQLQuery query;
 
 	/** The size. */
 	protected int size = -1;
@@ -72,7 +72,7 @@
 	/**
 	 * Instantiates a new query result.
 	 * 
-	 * Not intended to be used directly. See {@link Corpus#query(Query, String)}
+	 * Not intended to be used directly. See {@link Corpus#query(CQLQuery, String)}
 	 * 
 	 * @param cqpId
 	 *            the cqp id
@@ -87,7 +87,7 @@
 	 *             the invalid cqp id exception
 	 */
 	public QueryResult(String cqpId, String name, Corpus queriedCorpus,
-			Query query) throws InvalidCqpIdException {
+			CQLQuery query) throws InvalidCqpIdException {
 		// super(cqpId);
 		checkCqpId(cqpId);
 		this.cqpId = cqpId;
@@ -326,7 +326,7 @@
 	 * 
 	 * @return the query
 	 */
-	public Query getQuery() {
+	public CQLQuery getQuery() {
 		return query;
 	}
 	
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Part.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Part.java	(revision 1060)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Part.java	(revision 1061)
@@ -31,7 +31,7 @@
 import org.txm.objects.Project;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.clientExceptions.InvalidCqpIdException;
-import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
 import org.w3c.dom.Element;
 
 /**
@@ -60,7 +60,7 @@
 	 * @param query the query
 	 * @throws InvalidCqpIdException the invalid cqp id exception
 	 */
-	protected Part(String cqpId, String partitionName, String shortName, Partition partition, Query query) throws InvalidCqpIdException {
+	protected Part(String cqpId, String partitionName, String shortName, Partition partition, CQLQuery query) throws InvalidCqpIdException {
 		super(cqpId, partitionName + "_" + shortName, partition.getParent(), query, false); //$NON-NLS-1$
 		this.shortName = shortName;
 		this.name = shortName;
@@ -164,7 +164,7 @@
 	 * @param pquery the new query
 	 */
 	public void setQuery(String pquery) {
-		this.query = new Query(pquery);
+		this.query = new CQLQuery(pquery);
 	}
 
 	/* (non-Javadoc)
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Partition.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Partition.java	(revision 1060)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Partition.java	(revision 1061)
@@ -53,7 +53,7 @@
 import org.txm.searchengine.cqp.CQPPreferences;
 import org.txm.searchengine.cqp.CQPSearchEngine;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
-import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
 import org.txm.searchengine.cqp.corpus.query.QueryPart;
 import org.txm.utils.io.IOUtils;
 import org.txm.utils.logger.Log;
@@ -274,7 +274,7 @@
 		for (String value : pValues) {
 			String partName = value.replace("\\",""); //$NON-NLS-1$ //$NON-NLS-2$
 			pPartNames.add(partName);
-			Query query = new QueryPart(pProperty.getStructuralUnit(), pProperty, Query.addBackSlash(value));
+			CQLQuery query = new QueryPart(pProperty.getStructuralUnit(), pProperty, CQLQuery.addBackSlash(value));
 			pQueries.add(query.getQueryString());
 		}
 
@@ -378,7 +378,7 @@
 		long start = System.currentTimeMillis();
 		try {
 			CorpusManager.getCorpusManager().getCqiClient().cqpQuery(this.getParent().getQualifiedCqpId(), partCqpId, query);
-			part = new Part(partCqpId, partitionName, partName, this, new Query(query));
+			part = new Part(partCqpId, partitionName, partName, this, new CQLQuery(query));
 
 			// FIXME: persistence tests: define the UUID as the concatenation of all part CQP id
 //			this.uniqueID += partCqpId;
@@ -574,7 +574,7 @@
 	 * @throws CqiClientException
 	 *             the cqi client exception
 	 */
-	public List<QueryResult> query(Query query, String name) throws CqiClientException {
+	public List<QueryResult> query(CQLQuery query, String name) throws CqiClientException {
 		Log.finest(TXMCoreMessages.QUERYING_PARTITION + this.name);
 		List<Part> parts = getParts();
 		List<QueryResult> results = new ArrayList<QueryResult>(parts.size());
@@ -797,7 +797,7 @@
 	private static List<String> getSafeValues(StructuralUnitProperty property, Corpus corpus) throws CqiClientException	{
 		List<String> values = property.getValues(corpus);
 		for(int i = 0 ; i < values.size() ; i++)
-			values.set(i, Query.addBackSlash(values.get(i)));
+			values.set(i, CQLQuery.addBackSlash(values.get(i)));
 		return values;
 	}
 
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java	(revision 1060)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java	(revision 1061)
@@ -46,7 +46,7 @@
 import org.txm.searchengine.cqp.clientExceptions.InvalidCqpIdException;
 import org.txm.searchengine.cqp.core.functions.selection.SelectionResult;
 import org.txm.searchengine.cqp.corpus.query.Match;
-import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
 import org.txm.searchengine.cqp.corpus.query.QueryPart;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
 import org.txm.utils.logger.Log;
@@ -152,7 +152,7 @@
 	 * @throws CqiClientException the cqi client exception
 	 */
 	public Subcorpus createSubcorpus(Element elem) throws CqiClientException {
-		Query query = new Query(elem.getAttribute("query")); //$NON-NLS-1$
+		CQLQuery query = new CQLQuery(elem.getAttribute("query")); //$NON-NLS-1$
 		String subcorpusName = elem.getAttribute("name"); //$NON-NLS-1$
 
 		Subcorpus subcorpus;
@@ -184,7 +184,7 @@
 	 * @throws CqiClientException
 	 *             the cqi client exception
 	 */
-	public Subcorpus createSubcorpus(Query query, String subcorpusName)
+	public Subcorpus createSubcorpus(CQLQuery query, String subcorpusName)
 			throws CqiClientException {
 		Subcorpus sc = createSubcorpus(query, subcorpusName, false);
 		return sc;
@@ -199,7 +199,7 @@
 	 * @return the subcorpus
 	 * @throws CqiClientException the cqi client exception
 	 */
-	public Subcorpus createSubcorpus(Query query, String subcorpusName,
+	public Subcorpus createSubcorpus(CQLQuery query, String subcorpusName,
 			boolean registered) throws CqiClientException {
 		Subcorpus subcorpus;
 		String subcorpusCqpId = subcorpusNamePrefix + getNextSubcorpusCounter().toString();
@@ -266,10 +266,10 @@
 		}
 		String value = ""; //$NON-NLS-1$
 		for (String v : values)
-			value += Query.addBackSlash(v) + "|"; //$NON-NLS-1$
+			value += CQLQuery.addBackSlash(v) + "|"; //$NON-NLS-1$
 		value = value.substring(0, value.length() - 1);
 		
-		Query query = new QueryPart(structuralUnit, structuralUnitProperty, value);
+		CQLQuery query = new QueryPart(structuralUnit, structuralUnitProperty, value);
 		return createSubcorpus(query, subcorpusName);
 		//return createSubcorpus(structuralUnit, structuralUnitProperty, value, subcorpusName);
 	}
@@ -289,8 +289,8 @@
 	public Subcorpus createSubcorpus(StructuralUnit structuralUnit,
 			StructuralUnitProperty structuralUnitProperty, String value,
 			String subcorpusName) throws CqiClientException {
-		Query query = new QueryPart(structuralUnit, structuralUnitProperty,
-				Query.addBackSlash(value));
+		CQLQuery query = new QueryPart(structuralUnit, structuralUnitProperty,
+				CQLQuery.addBackSlash(value));
 		// System.out.println("forged query : "+query.getQueryString());
 		return createSubcorpus(query, subcorpusName);
 	}
@@ -310,7 +310,7 @@
 	public Subcorpus createSubcorpusWithQueryString(StructuralUnit structuralUnit,
 			StructuralUnitProperty structuralUnitProperty, String value,
 			String subcorpusName) throws CqiClientException {
-		Query query = new QueryPart(structuralUnit, structuralUnitProperty,
+		CQLQuery query = new QueryPart(structuralUnit, structuralUnitProperty,
 				value);
 		// System.out.println("forged query : "+query.getQueryString());
 		return createSubcorpus(query, subcorpusName);
@@ -842,8 +842,9 @@
 	 * @throws CqiClientException
 	 *             the cqi client exception
 	 */
-	public QueryResult query(Query query, String queryResultName, boolean save)
+	public QueryResult query(CQLQuery query, String queryResultName, boolean save)
 			throws CqiClientException {
+		
 		QueryResult queryResult = null;
 		//String queryResultId = queryResultNamePrefix + UUID.randomUUID().toString();
 		String queryResultId = queryResultNamePrefix + getNextQueryCounter();
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/AbstractCqiClient.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/AbstractCqiClient.java	(revision 1060)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/AbstractCqiClient.java	(revision 1061)
@@ -46,7 +46,7 @@
 import org.txm.searchengine.cqp.corpus.QueryResult;
 import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
 import org.txm.searchengine.cqp.corpus.query.Match;
-import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
 import org.txm.searchengine.cqp.serverException.CqiCqpErrorNoSuchCorpus;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
 import org.txm.utils.logger.Log;
@@ -97,7 +97,7 @@
 		
 		if (!isWordProperty) {
 			StructuralUnitProperty sprop = (StructuralUnitProperty) prop;
-			QueryResult qresult = prop.getCorpus().query(new Query("<"+sprop.getFullName()+">[] expand to "+sprop.getName()), "TMP", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+			QueryResult qresult = prop.getCorpus().query(new CQLQuery("<"+sprop.getFullName()+">[] expand to "+sprop.getName()), "TMP", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
 			int[] strucs = this.cpos2Struc(qname, qresult.getStarts());
 			return Arrays.asList(cqiClient.struc2Str(qname, strucs));
 		} else {
@@ -185,7 +185,7 @@
 	 * @throws CqiClientException the cqi client exception
 	 */
 	public List<String> getData(StructuralUnitProperty property, Corpus corpus) throws CqiClientException {
-			QueryResult tmp = corpus.query(new Query("<" + property.getFullName() + ">[]"), UUID.randomUUID().toString(), false); //$NON-NLS-1$ //$NON-NLS-2$
+			QueryResult tmp = corpus.query(new CQLQuery("<" + property.getFullName() + ">[]"), UUID.randomUUID().toString(), false); //$NON-NLS-1$ //$NON-NLS-2$
 			List<Match> matches = tmp.getMatches();
 			tmp.drop();
 			ArrayList<String> ret =  new ArrayList<String>(new HashSet<String>(Match
@@ -204,7 +204,7 @@
 		
 			QueryResult tmp = prop.getCorpus()
 					.query(
-							new Query("<" + prop.getFullName() + ">[] expand to "+prop.getName()), UUID.randomUUID().toString(), false); //$NON-NLS-1$ //$NON-NLS-2$
+							new CQLQuery("<" + prop.getFullName() + ">[] expand to "+prop.getName()), UUID.randomUUID().toString(), false); //$NON-NLS-1$ //$NON-NLS-2$
 			if (number > tmp.getNMatch()) number = tmp.getNMatch();
 			List<Match> matches = tmp.getMatches(0, number);
 			tmp.drop();
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/core/functions/summary/Summary.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/core/functions/summary/Summary.java	(revision 1060)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/core/functions/summary/Summary.java	(revision 1061)
@@ -15,7 +15,7 @@
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.searchengine.cqp.corpus.QueryResult;
 import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
-import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
 
 public class Summary extends TXMResult {
 	
@@ -68,10 +68,10 @@
 			String suname = properties.get(j).getStructuralUnit().getName();
 			//System.out.println("getting : "+properties.get(j).getFullName());
 
-			QueryResult result = corpus.query(new Query("<"+properties.get(j).getFullName()+">[]"), "summary", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+			QueryResult result = corpus.query(new CQLQuery("<"+properties.get(j).getFullName()+">[]"), "summary", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
 			int[] starts = result.getStarts();
 			result.drop();
-			result = corpus.query(new Query("[]</"+properties.get(j).getFullName()+">"), "summary", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+			result = corpus.query(new CQLQuery("[]</"+properties.get(j).getFullName()+">"), "summary", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
 			int[] ends = result.getStarts();
 			result.drop();
 			//System.out.println("starts: "+Arrays.toString(starts));
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/core/functions/selection/Selection.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/core/functions/selection/Selection.java	(revision 1060)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/core/functions/selection/Selection.java	(revision 1061)
@@ -47,7 +47,7 @@
 import org.txm.searchengine.cqp.corpus.StructuralUnit;
 import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
 import org.txm.searchengine.cqp.corpus.query.Match;
-import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
 import org.txm.utils.logger.Log;
 
@@ -64,7 +64,7 @@
 	Corpus corpus;
 	
 	/** The query to get texts metadatas and number. */
-	Query query;
+	CQLQuery query;
 	
 	/** The cqp positions of the texts start element. */
 	int[] positions;
@@ -103,7 +103,7 @@
 	public Selection(MainCorpus corpus) {
 		super(corpus);
 		// this query returns N results, where N is the number of text
-		this.query = new Query("<text>[]"); //$NON-NLS-1$
+		this.query = new CQLQuery("<text>[]"); //$NON-NLS-1$
 		this.corpus = corpus;
 		init();
 	}
@@ -168,7 +168,7 @@
 				this.metadatasValuesPerText.put(textids.get(i), new HashMap<String, String>());
 				
 				//QueryResult result2 = corpus.query(new Query("[_.text_id=\""+textids.get(i)+"\"] expand to text"), "temp", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-				QueryResult result2 = corpus.query(new Query("/region[text,a]:: a.text_id=\""+textids.get(i)+"\""), "temp", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+				QueryResult result2 = corpus.query(new CQLQuery("/region[text,a]:: a.text_id=\""+textids.get(i)+"\""), "temp", false); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
 				int tot = 0;
 				for (Match m : result2.getMatches(0,0))
 					tot += m.getEnd()- m.getStart();
